<?php
/**
* COMPONENT FILE HEADER
**/
namespace G3\A\E\Chronoconnectivity6\C;
/* @copyright:ChronoEngine.com @license:GPLv2 */defined('_JEXEC') or die('Restricted access');
defined("GCORE_SITE") or die;
class Connections extends \G3\A\E\Chronoconnectivity6\App {
	use \G3\A\C\T\DataOps;
	
	var $_models = array('\G3\A\E\Chronoconnectivity6\M\Connection', '\G3\A\M\Group');
	
	var $_helpers= array(
		'\G3\A\E\Chronofc\H\Field',
		'\G3\A\E\Chronofc\H\Parser',
	);
	
	function index(){
		//search
		$this->Search($this->Connection, ['title', 'desc']);
		
		$this->Paginate($this->Connection);
		
		$this->Order($this->Connection, ['connection_title' => 'Connection.title', 'connection_id' => 'Connection.id', 'connection_published' => 'Connection.published']);
		
		$connections = $this->Connection->select('all', ['json' => ['functions']]);
		$this->set('connections', $connections);
	}
	
	//data reading
	function edit(){
		
		if(isset($this->data['save']) OR isset($this->data['apply'])){
			$result = false;
			
			$this->DataOps()->chunk('_formchunks');
			
			if(!empty($this->data['Connection'])){
				$result = $this->Connection->save($this->data['Connection'], ['validate' => true, 'json' => ['params', 'events', 'views', 'functions', 'plugins', 'locales', 'rules'], 'alias' => ['title' => 'alias']]);
			}
			
			if($result === true){
				
				if(isset($this->data['apply'])){
					$redirect = r3('index.php?ext=chronoconnectivity6&cont=connections&act=edit&id='.$this->Connection->id);
				}else{
					$redirect = r3('index.php?ext=chronoconnectivity6&cont=connections');
				}
				return ['success' => rl3('Connection saved successfully.'), 'redirect' => $redirect];
			}else{
				
				$this->errors['Connection'] = $this->Connection->errors;
				unset($this->data['save']);
				unset($this->data['apply']);
				return ['error' => $this->Connection->errors, 'reload' => true];
			}
		}
		
		if(!empty($this->data['id'])){
			$connection = $this->Connection->where('id', $this->data('id', null))->select('first', ['json' => ['params', 'events', 'views', 'functions', 'plugins', 'locales', 'rules']]);
			if(!empty($connection)){
				$this->data = $connection;
			}
			$this->set('connection', $connection);
		}else{
			//default data
			if(empty($this->data['Connection'])){
				$this->data['Connection']['events'] = [
					'index' => ['name' => 'index', 'content' => ''],
					'view' => ['name' => 'view', 'content' => ''],
					'edit' => ['name' => 'edit', 'content' => ''],
				];
				$this->data['Connection']['locales'] = [
					'en_GB' => ['name' => 'en_GB', 'content' => ''],
				];
				$this->data['Connection']['views'] = [];
				$this->data['Connection']['functions'] = [];
				$this->data['Connection']['plugins'] = [];
			}
		}
		
		//get users groups for permissions
		$_groups = $this->Group->select('flat');
		$this->set('_groups', $_groups);
		$groups = array_merge([['Group' => ['id' => 'owner', 'title' => rl3('Owner'), '_depth' => 0]]], $_groups);
		$this->set('groups', $groups);
		
		if(class_exists('\G3\A\E\Chronoforms6\M\Block')){
			$Block = new \G3\A\E\Chronoforms6\M\Block();
			$blocks = $Block->fields(['id', 'title', 'type', 'group', 'desc'])->order(['title' => 'asc', 'group' => 'asc'])->where('published', 1)->select('all');
			$this->set('blocks', $blocks);
		}
	}
	
	function edit2(){
		
		if(isset($this->data['save']) OR isset($this->data['apply'])){
			$result = false;
			
			if(!empty($this->data['Connection'])){
				$result = $this->Connection->save($this->data['Connection'], ['validate' => true, 'json' => ['params', 'events', 'sections', 'views', 'functions', 'locales', 'rules'], 'alias' => ['title' => 'alias']]);
			}
			
			if($result === true){
				
				if(isset($this->data['apply'])){
					$redirect = r3('index.php?ext=chronoconnectivity6&cont=connections&act=edit2&id='.$this->Connection->id);
				}else{
					$redirect = r3('index.php?ext=chronoconnectivity6&cont=connections');
				}
				return ['success' => rl3('Connection saved successfully.'), 'redirect' => $redirect];
			}else{
				
				$this->errors['Connection'] = $this->Connection->errors;
				unset($this->data['save']);
				unset($this->data['apply']);
				return ['error' => $this->Connection->errors, 'reload' => true];
			}
		}
		
		if(!empty($this->data['id'])){
			$connection = $this->Connection->where('id', $this->data('id', null))->select('first', ['json' => ['params', 'events', 'sections', 'views', 'functions', 'locales', 'rules']]);
			if(!empty($connection)){
				$this->data = $connection;
			}
			$this->set('connection', $connection);
		}else{
			//default data
			if(empty($this->data['Connection'])){
				$this->data['Connection']['events'] = [
					'load' => ['name' => 'load', 'content' => ''],
					'submit' => ['name' => 'submit', 'content' => ''],
				];
				$this->data['Connection']['sections'] = [
					'one' => ['name' => 'one', 'content' => ''],
				];
				$this->data['Connection']['locales'] = [
					'en_GB' => ['name' => 'en_GB', 'content' => ''],
				];
				$this->data['Connection']['views'] = [];
				$this->data['Connection']['functions'] = [];
			}
		}
		
		//get users groups for permissions
		$_groups = $this->Group->select('flat');
		$this->set('_groups', $_groups);
		$groups = array_merge([['Group' => ['id' => 'owner', 'title' => rl3('Owner'), '_depth' => 0]]], $_groups);
		$this->set('groups', $groups);
	}
	
	function toggle(){
		return $this->toggleRecord($this->Connection);
	}
	
	function delete(){
		return $this->deleteRecord($this->Connection);
	}
	
	function copy(){
		if(is_array($this->data('gcb'))){
			
			$results = $this->Connection->where('id', $this->data('gcb'), 'in')->select();
			
			foreach($results as $result){
				unset($result['Connection']['id']);
				$result['Connection']['alias'] = $result['Connection']['alias'].'-copy';
				$this->Connection->save($result['Connection']);
			}
		}
		
		$this->redirect(r3('index.php?ext=chronoconnectivity6&cont=connections'));
	}
	
	function backup(){
		
		if(is_array($this->data('gcb'))){
			
			$results = $this->Connection->where('id', $this->data('gcb'), 'in')->select();
			$output = json_encode($results);
			
			$name = 'Connectivity66_'.\G3\L\Url::domain();
			if(count($results) == 1){
				$name = $results[0]['Connection']['title'];
			}
			
			// //download the file
			// if(preg_replace('Opera(/| )([0-9].[0-9]{1,2})', $_SERVER['HTTP_USER_AGENT'])){
			// 	$UserBrowser = 'Opera';
			// }elseif(preg_replace('MSIE ([0-9].[0-9]{1,2})', $_SERVER['HTTP_USER_AGENT'])){
			// 	$UserBrowser = 'IE';
			// }else{
			// 	$UserBrowser = '';
			// }
			// $mime_type = ($UserBrowser == 'IE' || $UserBrowser == 'Opera') ? 'application/octetstream' : 'application/octet-stream';
			$mime_type = 'application/octetstream';
			@ob_end_clean();
			ob_start();

			header('Content-Type: ' . $mime_type);
			header('Expires: ' . gmdate('D, d M Y H:i:s') . ' GMT');

			if ($UserBrowser == 'IE') {
				header('Content-Disposition: inline; filename="' . $name.'_'.date('d_M_Y_H:i:s').'.c6bak"');
				header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
				header('Pragma: public');
			}
			else {
				header('Content-Disposition: attachment; filename="' . $name.'_'.date('d_M_Y_H:i:s').'.c6bak"');
				header('Pragma: no-cache');
			}
			print $output;
			exit();
		}
		
		$this->redirect(r3('index.php?ext=chronoconnectivity6&cont=connections'));
	}
	
	function restore(){
		if(!empty($_FILES)){
			$file = $_FILES['backup'];
			
			if(!empty($file['size'])){
				
				$ext = strtolower(pathinfo($file['name'], PATHINFO_EXTENSION));
				
				if($ext != 'c6bak'){
					\GApp3::session()->flash('error', rl3('Invalid backup file extension.'));
					$this->redirect(r3('index.php?ext=chronoconnectivity6&cont=connections'));
				}
				
				$target = \G3\Globals::get('FRONT_PATH').'cache'.DS.$file['name'];
				
				$saved = \G3\L\Upload::save($file['tmp_name'], $target);
				
				if(!$saved){
					\GApp3::session()->flash('error', l_('Upload error'));
				}else{
					$data = file_get_contents($target);
					\G3\L\File::delete($target);
					
					$rows = json_decode($data, true);
					
					if(!empty($rows)){
						foreach($rows as $row){
							if(isset($row['Connection']['id'])){
								$row['Connection']['id'] = null;
								$row['Connection']['published'] = 0;
								$this->Connection->save($row['Connection']);
							}
						}
					}
					
					\GApp3::session()->flash('success', rl3('Connections restored successfully.'));
					$this->redirect(r3('index.php?ext=chronoconnectivity6&cont=connections'));
				}
			}
		}
	}
	
	function demos(){
		if($this->data('name')){
			$demo_path = \G3\Globals::ext_path('chronoconnectivity6', 'admin').'demos'.DS.$this->data('name').'.c6bak';
			$data = file_get_contents($demo_path);
			
			$data = str_replace('1con61_', \G3\L\Config::get('db.prefix'), $data);
			$rows = json_decode($data, true);
			
			$rows[0]['Connection']['id'] = null;
			$rows[0]['Connection']['title'] = null;
			$rows[0]['Connection']['alias'] = null;
			$rows[0]['Connection']['rules'] = json_decode($rows[0]['Connection']['rules'], true);
			$rows[0]['Connection']['locales'] = json_decode($rows[0]['Connection']['locales'], true);
			$rows[0]['Connection']['events'] = json_decode($rows[0]['Connection']['events'], true);
			$rows[0]['Connection']['views'] = json_decode($rows[0]['Connection']['views'], true);
			$rows[0]['Connection']['functions'] = json_decode($rows[0]['Connection']['functions'], true);
			
			$this->data['Connection'] = $rows[0]['Connection'];
		}
		$this->edit();
		$this->view = 'edit';
	}
	
	function clear_cache(){
		$this->redirect(r3('index.php?ext=chronoconnectivity6&act=clear_cache'));
	}
	
	function block_config(){
		$this->set('type', $this->data('name'));
		$this->set('name', $this->data('name'));
		$this->set('count', $this->data('count'));
		
		$this->view = $this->data('block').'_config';
		
		//get users groups for permissions
		$groups = array_merge([['Group' => ['id' => 'owner', 'title' => rl3('Owner'), '_depth' => 0]]], $this->Group->select('flat'));
		$this->set('groups', $groups);
		
		if(class_exists('\G3\A\E\Chronoforms6\M\Block')){
			$Block = new \G3\A\E\Chronoforms6\M\Block();
			$blocks = $Block->fields(['id', 'title', 'type', 'group', 'desc'])->order(['title' => 'asc', 'group' => 'asc'])->where('published', 1)->select('all');
			$this->set('blocks', $blocks);
		}
	}
	
	function events_config(){
		$this->set('name', $this->data('name'));
		
		//get users groups for permissions
		$groups = array_merge([['Group' => ['id' => 'owner', 'title' => rl3('Owner'), '_depth' => 0]]], $this->Group->select('flat'));
		$this->set('groups', $groups);
	}
	
	function locales_config(){
		$this->set('name', $this->data('name'));
	}
	
	function function_config($type = 'functions'){
		$this->view = \G3\Globals::ext_path('chronofc', 'admin').$type.DS.$this->data('type').DS.$this->data('id').'.php';
		
		if($this->data('params')){
			foreach($this->data('params') as $param){
				$this->set($param, $this->data($param));
			}
		}
		
		$this->set('n', $this->data('count'));
	}
	
	function view_config(){
		$this->function_config('views');
	}
	
	
	///////////////////
	function block_config2(){
		$this->set('type', $this->data('name'));
		$this->set('name', $this->data('name'));
		$this->set('count', $this->data('count'));
		
		$this->view = $this->data('block').'_config2';
		
		//get users groups for permissions
		$groups = array_merge([['Group' => ['id' => 'owner', 'title' => rl3('Owner'), '_depth' => 0]]], $this->Group->select('flat'));
		$this->set('groups', $groups);
	}
	
	function events_config2(){
		$this->set('name', $this->data('name'));
		
		//get users groups for permissions
		$groups = array_merge([['Group' => ['id' => 'owner', 'title' => rl3('Owner'), '_depth' => 0]]], $this->Group->select('flat'));
		$this->set('groups', $groups);
	}
	
	function sections_config2(){
		$this->set('name', $this->data('name'));
		
		//get users groups for permissions
		$groups = array_merge([['Group' => ['id' => 'owner', 'title' => rl3('Owner'), '_depth' => 0]]], $this->Group->select('flat'));
		$this->set('groups', $groups);
	}
}
?>