<?php
/* @copyright:ChronoEngine.com @license:GPLv2 */defined('_JEXEC') or die('Restricted access');
defined("GCORE_SITE") or die;
?>

<form action="<?php echo r3('index.php?ext=chronoconnectivity6&cont=connections'); ?>" method="post" name="admin_form" id="admin_form" class="ui form">
	
	<h2 class="ui header"><?php el3('Connections manager'); ?></h2>
	<div class="ui">
		<div class="ui labeled icon dropdown button blue compact pointing">
			<i class="faicon plus icon"></i>
			<span class="text"><?php el3('New'); ?></span>
			<div class="menu">
				<a class="item" href="<?php echo r3('index.php?ext=chronoconnectivity6&cont=connections&act=demos'); ?>">
					<?php el3('Empty connection'); ?>
				</a>
			</div>
		</div>
		<div class="ui labeled icon dropdown button green compact pointing">
			<i class="faicon plus icon"></i>
			<span class="text"><?php el3('Demos'); ?></span>
			<div class="menu">
				<a class="item" href="<?php echo r3('index.php?ext=chronoconnectivity6&cont=connections&act=demos&name=articles1'); ?>">
					<?php el3('Basic articles list'); ?>
				</a>
				<a class="item" href="<?php echo r3('index.php?ext=chronoconnectivity6&cont=connections&act=demos&name=articles2'); ?>">
					<?php el3('Dynamic actions'); ?>
				</a>
				<a class="item" href="<?php echo r3('index.php?ext=chronoconnectivity6&cont=connections&act=demos&name=articles3'); ?>">
					<?php el3('Articles relations'); ?>
				</a>
				<a class="item" href="<?php echo r3('index.php?ext=chronoconnectivity6&cont=connections&act=demos&name=articles4'); ?>">
					<?php el3('Custom articles listing'); ?>
				</a>
			</div>
		</div>
		<button type="button" class="compact ui button red icon labeled toolbar-button" data-url="<?php echo r3('index.php?ext=chronoconnectivity6&cont=connections&act=delete'); ?>">
			<i class="faicon trash icon"></i><?php el3('Delete'); ?>
		</button>
		<button type="button" class="compact ui button teal icon labeled toolbar-button" data-url="<?php echo r3('index.php?ext=chronoconnectivity6&cont=connections&act=copy'); ?>">
			<i class="faicon copy icon"></i><?php el3('Copy'); ?>
		</button>
		<button type="button" class="compact ui button orange icon labeled toolbar-button" data-url="<?php echo r3('index.php?ext=chronoconnectivity6&cont=connections&act=backup'); ?>">
			<i class="faicon download icon"></i><?php el3('Backup'); ?>
		</button>
		<a class="compact ui button blue icon labeled" href="<?php echo r3('index.php?ext=chronoconnectivity6&cont=connections&act=restore'); ?>">
			<i class="faicon upload icon"></i><?php el3('Restore'); ?>
		</a>
		<a class="compact ui button purple icon labeled" href="<?php echo r3('index.php?ext=chronoconnectivity6&cont=tables&act=build'); ?>">
			<i class="faicon database icon"></i><?php el3('Create table'); ?>
		</a>
	</div>
	
	<div class="ui clearing divider"></div>
	
	<table class="ui selectable table">
		<thead>
			<tr>
				<th class="">
					<div class="ui select_all checkbox">
						<input type="checkbox">
						<label></label>
					</div>
				</th>
				<th class="single line"><?php echo $this->Sorter->link(rl3('ID'), 'connection_id'); ?></th>
				<th class=""><?php echo $this->Sorter->link(rl3('Title'), 'connection_title'); ?></th>
				<th class=""><?php el3('Alias'); ?></th>
				<th class="five wide"><?php el3('Description'); ?></th>
				<th class="single line"><?php el3('Data tables'); ?></th>
				<th class="single line"><?php echo $this->Sorter->link(rl3('Public'), 'connection_public'); ?></th>
				<th class="single line"><?php echo $this->Sorter->link(rl3('Published'), 'connection_published'); ?></th>
				<th class=""><?php el3('Display'); ?></th>
			</tr>
		</thead>
		<tbody>
			<?php foreach($connections as $i => $connection): ?>
			<tr>
				<td class="collapsing">
					<div class="ui checkbox selector">
						<input type="checkbox" class="hidden" name="gcb[]" value="<?php echo $connection['Connection']['id']; ?>">
						<label></label>
					</div>
				</td>
				<td class="collapsing"><?php echo $connection['Connection']['id']; ?></td>
				<td><?php echo $this->Html2->attr('href', r3('index.php?ext=chronoconnectivity6&cont=connections&act=edit'.rp3('id', $connection['Connection'])))->content($connection['Connection']['title'])->tag('a'); ?></td>
				<td><?php echo $connection['Connection']['alias']; ?></td>
				<td><?php echo $connection['Connection']['description']; ?></td>
				<td><?php $this->view('views.connections.connected_tables', ['connection' => $connection]); ?></td>
				<td>
					<?php
						echo $this->Html2
						->attr('href', r3('index.php?ext=chronoconnectivity6&cont=connections&act=toggle'.rp3('gcb', $connection['Connection']['id']).rp3('fld', 'public').rp3('val', (int)!(bool)$connection['Connection']['public'])))
						->addClass('compact ui button icon mini circular '.((int)$connection['Connection']['public'] ? 'green' : 'red'))
						->content('<i class="faicon '.((int)$connection['Connection']['public'] ? 'check' : 'times').'"></i>')
						->tag('a');
					?>
				</td>
				<td>
					<?php
						echo $this->Html2
						->attr('href', r3('index.php?ext=chronoconnectivity6&cont=connections&act=toggle'.rp3('gcb', $connection['Connection']['id']).rp3('fld', 'published').rp3('val', (int)!(bool)$connection['Connection']['published'])))
						->addClass('compact ui button icon mini circular '.((int)$connection['Connection']['published'] ? 'green' : 'red'))
						->content('<i class="faicon '.((int)$connection['Connection']['published'] ? 'check' : 'times').'"></i>')
						->tag('a');
					?>
				</td>
				<td><?php echo $this->Html2->attr('href', r3('index.php?ext=chronoconnectivity6&cont=manager'.rp3('conn', $connection['Connection']['alias'])))->attr('target', '_blank')->content(rl3('Open'))->tag('a'); ?></td>
			</tr>
			<?php endforeach; ?>
		</tbody>
		<tfoot>
			<tr>
				<th colspan="9">
				<?php echo $this->Paginator->navigation('Connection'); ?>
				<?php echo $this->Paginator->limiter('Connection'); ?>
				</th>
			</tr>
		</tfoot>
	</table>
	
</form>
