<?php
/* @copyright:ChronoEngine.com @license:GPLv2 */defined('_JEXEC') or die('Restricted access');
defined("GCORE_SITE") or die;
?>

<form action="<?php echo r3('index.php?ext=chronoforms6&cont=blocks'); ?>" method="post" name="admin_form" id="admin_form" class="ui form">
	
	<h2 class="ui header"><?php el3('Blocks manager'); ?></h2>
	<div class="ui">
		<div class="ui labeled icon dropdown button compact pointing blue">
			<i class="faicon magic icon"></i>
			<span class="text"><?php el3('New'); ?></span>
			<div class="menu">
				<a class="item" href="<?php echo r3('index.php?ext=chronoforms6&cont=blocks&act=edit&Block[type]=views'); ?>">
					<?php el3('Views block'); ?>
				</a>
				<a class="item" href="<?php echo r3('index.php?ext=chronoforms6&cont=blocks&act=edit&Block[type]=functions'); ?>">
					<?php el3('Functions block'); ?>
				</a>
			</div>
		</div>
		<button type="button" class="compact ui button red icon labeled toolbar-button" data-selections="1" data-message="<?php el3('Please make a selection.'); ?>" data-url="<?php echo r3('index.php?ext=chronoforms6&cont=blocks&act=delete'); ?>">
			<i class="faicon times icon"></i><?php el3('Delete'); ?>
		</button>
		<button type="button" class="compact ui button teal icon labeled toolbar-button" data-selections="1" data-message="<?php el3('Please make a selection.'); ?>" data-url="<?php echo r3('index.php?ext=chronoforms6&cont=blocks&act=copy'); ?>">
			<i class="faicon copy icon"></i><?php el3('Copy'); ?>
		</button>
		<button type="button" class="compact ui button orange icon labeled toolbar-button" data-selections="1" data-message="<?php el3('Please make a selection.'); ?>" data-url="<?php echo r3('index.php?ext=chronoforms6&cont=blocks&act=backup'); ?>">
			<i class="faicon download icon"></i><?php el3('Backup'); ?>
		</button>
		<a class="compact ui button blue icon labeled toolbar-button" href="<?php echo r3('index.php?ext=chronoforms6&cont=blocks&act=restore'); ?>">
			<i class="faicon upload icon"></i><?php el3('Restore'); ?>
		</a>
	</div>
	
	<div class="ui clearing divider"></div>
	
	<div class="ui message top attached" style="padding:7px 12px;">
		<div class="ui action input" style="float:left;">
			<input type="text" name="search" placeholder="<?php el3('Find blocks...'); ?>">
			<button class="ui icon button">
			<i class="faicon search icon"></i>
			</button>
		</div>
		<div style="float:right;">
			<?php echo $this->Paginator->navigation('Block'); ?>
			<?php echo $this->Paginator->limiter('Block'); ?>
		</div>
		<div style="clear:both;"></div>
	</div>
	<table class="ui selectable table attached">
		<thead>
			<tr>
				<th class="">
					<div class="ui select_all checkbox">
						<input type="checkbox">
						<label></label>
					</div>
				</th>
				<th class="single line"><?php echo $this->Sorter->link(rl3('ID'), 'block_id'); ?></th>
				<th class="eight wide"><?php echo $this->Sorter->link(rl3('Title'), 'block_title'); ?></th>
				<th class="single line"><?php el3('Block ID'); ?></th>
				<th class="single line"><?php el3('Type'); ?></th>
				<th class="single line"><?php el3('Group'); ?></th>
				<th class="single line"><?php echo $this->Sorter->link(rl3('Enabled'), 'block_published'); ?></th>
			</tr>
		</thead>
		<tbody>
			<?php foreach($blocks as $i => $Block): ?>
			<tr>
				<td class="collapsing">
					<div class="ui checkbox selector">
						<input type="checkbox" class="hidden" name="gcb[]" value="<?php echo $Block['Block']['id']; ?>">
						<label></label>
					</div>
				</td>
				<td class="collapsing"><?php echo $Block['Block']['id']; ?></td>
				<td>
					<?php echo $this->Html2->attr('href', r3('index.php?ext=chronoforms6&cont=blocks&act=edit'.rp3('id', $Block['Block'])))->content($Block['Block']['title'])->tag('a'); ?>
					<br>
					<small><?php echo nl2br($Block['Block']['desc']); ?></small>
				</td>
				<td class="collapsing"><?php echo $Block['Block']['block_id']; ?></td>
				<td class="collapsing">
					<?php if($Block['Block']['type'] == 'views'): ?>
						<div class="ui label blue">
					<?php elseif($Block['Block']['type'] == 'functions'): ?>
						<div class="ui label red">
					<?php endif; ?>
					<?php echo ucfirst($Block['Block']['type']); ?>
					</div>
				</td>
				<td class="collapsing">
					<?php if(!empty($Block['Block']['group'])): ?>
					<div class="ui label black"><?php echo $Block['Block']['group']; ?></div>
					<?php endif; ?>
				</td>
				<td>
					<?php
						echo $this->Html2
						->attr('href', r3('index.php?ext=chronoforms6&cont=blocks&act=toggle'.rp3('gcb', $Block['Block']['id']).rp3('fld', 'published').rp3('val', (int)!(bool)$Block['Block']['published'])))
						->addClass('compact ui button icon mini circular '.((int)$Block['Block']['published'] ? 'green' : 'red'))
						->content('<i class="faicon '.((int)$Block['Block']['published'] ? 'check' : 'cancel').'"></i>')
						->tag('a');
					?>
				</td>
			</tr>
			<?php endforeach; ?>
		</tbody>
	</table>
	<div class="ui message bottom attached" style="padding:7px 12px;">
		<div style="float:right">
			<?php echo $this->Paginator->navigation('Block'); ?>
			<?php echo $this->Paginator->limiter('Block'); ?>
		</div>
		<div style="clear:both;"></div>
	</div>
	
</form>
