<?php
/* @copyright:ChronoEngine.com @license:GPLv2 */defined('_JEXEC') or die('Restricted access');
defined("GCORE_SITE") or die;
?>
<div class="ui segment tab functions-tab active" data-tab="function-<?php echo $n; ?>">

	<div class="ui top attached tabular menu small G3-tabs">
		<a class="item active" data-tab="function-<?php echo $n; ?>-general"><?php el3('General'); ?></a>
		<a class="item" data-tab="function-<?php echo $n; ?>-style"><?php el3('Style'); ?></a>
		<a class="item" data-tab="function-<?php echo $n; ?>-modal"><?php el3('Popup'); ?></a>
		<a class="item" data-tab="function-<?php echo $n; ?>-permissions"><?php el3('Permissions'); ?></a>
	</div>
	
	<div class="ui bottom attached tab segment active" data-tab="function-<?php echo $n; ?>-general">
		<input type="hidden" value="display_section" name="Connection[functions][<?php echo $n; ?>][type]">
		
		<div class="two fields advanced_conf">
			<div class="field">
				<label><?php el3('Name'); ?></label>
				<input type="text" value="" name="Connection[functions][<?php echo $n; ?>][name]">
			</div>
		</div>
		
		<div class="ui segment active" data-tab="function-<?php echo $n; ?>">
			
			<div class="two fields">
				<div class="field required">
					<label><?php el3('Sections names'); ?></label>
					<textarea rows="3" name="Connection[functions][<?php echo $n; ?>][sections]">one</textarea>
				</div>
				
				<div class="field">
					<label><?php el3('Container type'); ?></label>
					<select name="Connection[functions][<?php echo $n; ?>][display_type]" class="ui fluid dropdown">
						<option value="form"><?php el3('Form'); ?></option>
						<option value="div"><?php el3('Div .ui.form'); ?></option>
						<option value="pure"><?php el3('None'); ?></option>
					</select>
					<small><?php el3('In all cases this should be set to "Form", unless you do not want a form element added, for example when loading dynamic content into an existing form.'); ?></small>
				</div>
			</div>
			
			<div class="ui header dividing"><?php el3('Form settings'); ?></div>
			
			<div class="two fields">
				<div class="field">
					<label><?php el3('Data provider'); ?></label>
					<input type="text" value="" name="Connection[functions][<?php echo $n; ?>][data_provider]">
				</div>
				<div class="field">
					<label><?php el3('Validation messages'); ?></label>
					<select name="Connection[functions][<?php echo $n; ?>][validation][type]" class="ui fluid dropdown">
						<option value="inline"><?php el3('Inline tooltips'); ?></option>
						<option value="inlinetext"><?php el3('Inline error messages'); ?></option>
						<option value="message"><?php el3('Errors list below form'); ?></option>
					</select>
				</div>
			</div>
			
			<div class="two fields">
				<div class="field">
					<label><?php el3('Submit Event'); ?></label>
					<input type="text" value="submit" name="Connection[functions][<?php echo $n; ?>][event]">
					<small class="field-desc"><?php el3('The event to which the form data will be sent.'); ?></small>
				</div>
				
				<div class="field">
					<label><?php el3('Submit animation'); ?></label>
					<select name="Connection[functions][<?php echo $n; ?>][submit_animation]" class="ui fluid dropdown">
						<option value="1"><?php el3('Yes'); ?></option>
						<option value=""><?php el3('No'); ?></option>
					</select>
					<small><?php el3('When enabled, the form will display a loading icon when its submitting the data to server.'); ?></small>
				</div>
				
			</div>
			
			<div class="field">
				<label><?php el3('Action URL and/or parameters'); ?></label>
				<input type="text" value="" name="Connection[functions][<?php echo $n; ?>][parameters]">
				<small class="field-desc"><?php el3('The url to which the form data will be sent, use this only if you have a custom form.'); ?></small>
			</div>
			
			<div class="three fields">
				
				<div class="field">
					<label><?php el3('AJAX submit'); ?></label>
					<select name="Connection[functions][<?php echo $n; ?>][dynamic]" class="ui fluid dropdown">
						<option value=""><?php el3('No'); ?></option>
						<option value="1"><?php el3('Yes'); ?></option>
					</select>
				</div>
				
				<div class="field">
					<label><?php el3('Invisible form'); ?></label>
					<select name="Connection[functions][<?php echo $n; ?>][invisible]" class="ui fluid dropdown">
						<option value=""><?php el3('No'); ?></option>
						<option value="1"><?php el3('Yes'); ?></option>
					</select>
					<small class="field-desc"><?php el3('When enabled, the form tag will not be available until the page is loaded.'); ?></small>
				</div>
				
				<div class="field">
					<label><?php el3('KeepAlive'); ?></label>
					<select name="Connection[functions][<?php echo $n; ?>][keepalive]" class="ui fluid dropdown">
						<option value=""><?php el3('No'); ?></option>
						<option value="1"><?php el3('Yes'); ?></option>
					</select>
					<small class="field-desc"><?php el3('When enabled, the user session will not expire when the form is opened.'); ?></small>
				</div>
			</div>
			
			<div class="equal width fields">
				<div class="field">
					<label><?php el3('Form ID'); ?></label>
					<input type="text" value="" placeholder="<?php el3('Auto'); ?>" name="Connection[functions][<?php echo $n; ?>][formid]">
				</div>
			</div>
			
			<div class="field">
				<label><?php el3('Form tag attributes'); ?></label>
				<textarea rows="3" name="Connection[functions][<?php echo $n; ?>][attrs]" placeholder="<?php el3('Multiline list of attributes'); ?>"></textarea>
			</div>
			
		</div>
		
	</div>
	
	<div class="ui bottom attached tab segment" data-tab="function-<?php echo $n; ?>-style">
		<div class="equal width fields">
			<div class="field">
				<label><?php el3('Class'); ?></label>
				<input type="text" value="ui form" name="Connection[functions][<?php echo $n; ?>][class]">
				<small class="field-desc"><?php el3('A class to apply to your form, changing this may affect your form appearance.'); ?></small>
			</div>
			<div class="field">
				<label><?php el3('Size'); ?></label>
				<select name="Connection[functions][<?php echo $n; ?>][size]" class="ui fluid dropdown">
					<option value=""><?php el3('Default'); ?></option>
					<option value="mini"><?php el3('Mini'); ?></option>
					<option value="tiny"><?php el3('Tiny'); ?></option>
					<option value="small"><?php el3('Small'); ?></option>
					<option value="large"><?php el3('Large'); ?></option>
					<option value="big"><?php el3('Big'); ?></option>
					<option value="huge"><?php el3('Huge'); ?></option>
					<option value="massive"><?php el3('Massive'); ?></option>
				</select>
				<small class="field-desc"><?php el3('Select the size class of the form element.'); ?></small>
			</div>
		</div>
	</div>
	
	<div class="ui bottom attached tab segment" data-tab="function-<?php echo $n; ?>-modal">
		<div class="two fields">
			<div class="field">
				<label><?php el3('Popup modal'); ?></label>
				<select name="Connection[functions][<?php echo $n; ?>][modal][enabled]" class="ui fluid dropdown">
					<option value=""><?php el3('No'); ?></option>
					<option value="1"><?php el3('Yes'); ?></option>
				</select>
				<small><?php el3('Display form in a popup modal'); ?></small>
			</div>
			<div class="field">
				<label><?php el3('Show on page load'); ?></label>
				<select name="Connection[functions][<?php echo $n; ?>][modal][pageload]" class="ui fluid dropdown">
					<option value=""><?php el3('No'); ?></option>
					<option value="1" selected="selected"><?php el3('Yes'); ?></option>
				</select>
				<small><?php el3('Display the form popup when the page has finished loading.'); ?></small>
			</div>
		</div>
		<div class="field">
			<label><?php el3('Popup header'); ?></label>
			<input type="text" value="" name="Connection[functions][<?php echo $n; ?>][modal][header]">
			<small><?php el3('The header text of the modal or leave empty.'); ?></small>
		</div>
		
		<div class="field">
			<label><?php el3('Display after x miliseconds'); ?></label>
			<input type="text" value="" name="Connection[functions][<?php echo $n; ?>][modal][delay]">
			<small><?php el3('Display the form popup after x miliseconds of page load.'); ?></small>
		</div>
		<div class="field">
			<label><?php el3('Display after scroll space'); ?></label>
			<input type="text" value="" name="Connection[functions][<?php echo $n; ?>][modal][scroll]">
			<small><?php el3('Display the form popup after the page has been scrolled x px.'); ?></small>
		</div>
		<div class="field">
			<label><?php el3('Display on click of'); ?></label>
			<input type="text" value="" name="Connection[functions][<?php echo $n; ?>][modal][trigger]">
			<small><?php el3('The selector of the element to trigger the form popup, use #element_id or .element_class'); ?></small>
		</div>
		<div class="field">
			<label><?php el3('Replacement views'); ?></label>
			<textarea name="Connection[functions][<?php echo $n; ?>][modal][replacement]" rows="5"></textarea>
			<small><?php el3('Enter any code to be displayed instead of the form, the code may contain the trigger element.'); ?></small>
		</div>
		<div class="two fields">
			<div class="field">
				<label><?php el3('Modal size'); ?></label>
				<select name="Connection[functions][<?php echo $n; ?>][modal][size]" class="ui fluid dropdown">
					<option value="fullscreen"><?php el3('Full screen'); ?></option>
					<option value="small"><?php el3('Small'); ?></option>
					<option value="tiny"><?php el3('Smaller'); ?></option>
					<option value="mini"><?php el3('Smallest'); ?></option>
				</select>
				<small><?php el3('The width of the popup modal.'); ?></small>
			</div>
			<div class="field">
				<label><?php el3('Basic layout'); ?></label>
				<select name="Connection[functions][<?php echo $n; ?>][modal][basic]" class="ui fluid dropdown">
					<option value=""><?php el3('No'); ?></option>
					<option value="1"><?php el3('Ye'); ?></option>
				</select>
				<small><?php el3('A basic layout has no popup frame.'); ?></small>
			</div>
		</div>
		<div class="two fields">
			<div class="field">
				<label><?php el3('Close icon'); ?></label>
				<select name="Connection[functions][<?php echo $n; ?>][modal][close_icon]" class="ui fluid dropdown">
					<option value="1"><?php el3('Yes'); ?></option>
					<option value=""><?php el3('No'); ?></option>
				</select>
				<small><?php el3('Display a close button ?'); ?></small>
			</div>
		</div>
		<div class="two fields">
			<div class="field">
				<label><?php el3('Closable'); ?></label>
				<select name="Connection[functions][<?php echo $n; ?>][modal][closable]" class="ui fluid dropdown">
					<option value="1"><?php el3('Yes'); ?></option>
					<option value=""><?php el3('No'); ?></option>
				</select>
				<small><?php el3('Will close when the background is clicked.'); ?></small>
			</div>
			<div class="field">
				<label><?php el3('Light background'); ?></label>
				<select name="Connection[functions][<?php echo $n; ?>][modal][inverted]" class="ui fluid dropdown">
					<option value="1"><?php el3('Yes'); ?></option>
					<option value=""><?php el3('No'); ?></option>
				</select>
				<small><?php el3('The popup background will be white.'); ?></small>
			</div>
		</div>
	</div>
	
	<div class="ui bottom attached tab segment" data-tab="function-<?php echo $n; ?>-permissions">
		<?php $this->view('views.config_permissions', ['type' => 'functions', 'n' => $n]); ?>
	</div>
	
</div>